<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
        const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
        const gEND_ROW_TABLE = -1;
        // hằng số số thứ tự các cột
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOC_UONG = 3;
        const gCOLUMN_THANH_TIEN = 4;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SDT = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vPerson = JSON.parse(paramXMLHttpAllOrder.responseText);
            console.log(vPerson);
            var vTable = document.getElementById("table-order");
            var vTbody = document.getElementsByTagName("tbody")[0];
            for (var bI = 0; bI < vPerson.length; bI++) {
                var bRowBody = vTbody.insertRow(gEND_ROW_TABLE);
                var bCellOrder = bRowBody.insertCell(gCOLUMN_ORDER_CODE);
                var bCellKichCo = bRowBody.insertCell(gCOLUMN_KICH_CO);
                var bCellLoaiPizza = bRowBody.insertCell(gCOLUMN_LOAI_PIZZA);
                var bCellNuocUong = bRowBody.insertCell(gCOLUMN_NUOC_UONG);
                var bCellTien = bRowBody.insertCell(gCOLUMN_THANH_TIEN);
                var bCellHoTen = bRowBody.insertCell(gCOLUMN_HO_TEN);
                var bCellSoDT = bRowBody.insertCell(gCOLUMN_SDT);
                var bCellStatus = bRowBody.insertCell(gCOLUMN_TRANG_THAI);
                var bCellAction = bRowBody.insertCell(gCOLUMN_ACTION);
                //
                bCellOrder.innerHTML = vPerson[bI].orderCode;
                bCellKichCo.innerHTML = vPerson[bI].kichCo;
                bCellLoaiPizza.innerHTML = vPerson[bI].loaiPizza;
                bCellNuocUong.innerHTML = vPerson[bI].idLoaiNuocUong;
                bCellTien.innerHTML = vPerson[bI].thanhTien;
                bCellHoTen.innerHTML = vPerson[bI].hoTen;
                bCellSoDT.innerHTML = vPerson[bI].soDienThoai;
                bCellStatus.innerHTML = vPerson[bI].trangThai;
                var vButton = document.createElement("button");
                vButton.innerHTML = "Chi Tiết";
                vButton.className = "btn btn-success";
                vButton.setAttribute("data-id",vPerson[bI].id);
                vButton.setAttribute("data-orderCode",vPerson[bI].orderCode);
                bCellAction.appendChild(vButton);
                vButton.addEventListener("click", function () {
                    eventDataSet(this);
                }
                )
            }
        }
        //
        function eventDataSet(paramUser)
        {
            var vId = paramUser.dataset.id ;
            console.log(vId);
            var vOrder = paramUser.dataset.ordercode ;
            
            console.log(vOrder);
            
        }


    </script>
</body>

</html>